aqua_gauge/aqua_gauge/urls.py
from django.contrib import admin
from django.urls import path,include


urlpatterns = [
    path('',include('publics.urls')),
    path('manage/',include('user_auth.urls')),
    path('schools/',include('schools.urls')),
    path('admin/', include('super_admin.urls')),
    path('graphs/', include('graphs.urls')),
    # path('admin/', admin.site.urls), 
]

aqua_gauge/graphs/urls.py
from django.contrib import admin
from django.urls import path,include
from . import views


urlpatterns = [
    path('',views.home,name="graph-home"),
    path('wells',views.wells,name="data-wells"),
    path('well/<int:id>/<str:time_range>',views.well_data,name="data-well"),
]

aqua_gauge/graphs/models.py
from django.db import models

# Create your models here.

aqua_gauge/schools/models.py
from django.db import models
from django.contrib.auth.models import User

class School(models.Model):
    TYPE_CHOICES = (
        ('Public', 'Public'),
        ('Private', 'Private')
    )

    name = models.CharField(max_length=255)
    type = models.CharField(max_length=10, choices=TYPE_CHOICES)
    address = models.CharField(max_length=255)
    phone_number = models.CharField(max_length=20)
    email = models.EmailField()
    website = models.URLField(blank=True)
    country = models.CharField(max_length=255)
    state_province = models.CharField(max_length=255)
    city = models.CharField(max_length=255)
    district = models.CharField(max_length=255)
    user = models.ForeignKey(User, on_delete=models.CASCADE)

    def __str__(self):
        return self.name

aqua_gauge/graphs/views.py
from django.shortcuts import render
from schools.models import School
from wells.models import Well
from wells.models import WellData
from django.http import JsonResponse
import datetime
from zoneinfo import ZoneInfo
from .well_serializer import WellDataSerializer
import json


# get previous datetime with format (yyyy-MM-ddTHH:mm:ss.fZ)
def get_timedate_range(minutes=0,hours=0,days=0,weeks=0,months=0,years=0 ):
    if(years != 0):
        months = years * 12
    if(months != 0 ):
        days = months * 30
    crnt_time = datetime.datetime.now(tz=ZoneInfo('Asia/Kolkata')) #datetime.timezone.utc
    compare_time = crnt_time - datetime.timedelta(minutes = minutes,hours=hours,days=days,weeks=weeks)
    previous_date = compare_time.strftime("%Y-%m-%dT%H:%M:%S.%fZ")
    crnt_date = crnt_time.strftime("%Y-%m-%dT%H:%M:%S.%fZ")
    return [crnt_date,previous_date]


def home(request):
    schools = School.objects.values('id', 'name')
    return render(request,"graphs/home.html",{
        'schools':schools
    })

def wells(request):
    school_id = request.GET['school_id']
    school = School.objects.get(pk=school_id)
    wells = Well.objects.filter(school=school).values('id','label')
    well_level = []
    for each in wells:
        try:
             wellDataObj = WellData.objects.filter(well_id=each['id']).order_by('datetime')[0]
             well_level.append({'label':each['label'],'level':wellDataObj.water_level})
        except Exception as e:
            print(e)
            well_level.append({'label':each['label'],'level':0})

    return JsonResponse({
        'wells' : list(wells),
        'well_level':well_level
    })

def well_data(request,id,time_range):
    well_id = id
    time_ = get_timedate_range(minutes=0,hours=0,days=1,weeks=0,months=0,years=0 )
    if(time_range == 'h-24'):
        time_ = get_timedate_range(minutes=0,hours=0,days=1,weeks=0,months=0,years=0 )
    if(time_range == 'd-1'):
        time_ = get_timedate_range(minutes=0,hours=0,days=1,weeks=0,months=0,years=0 )
    if(time_range == 'w-1'):
        time_ = get_timedate_range(minutes=0,hours=0,days=0,weeks=1,months=0,years=0 )
    if(time_range == 'm-1'):
        time_ = get_timedate_range(minutes=0,hours=0,days=0,weeks=0,months=1,years=0 )
    if(time_range == 'y-1'):
        time_ = get_timedate_range(minutes=0,hours=0,days=1,weeks=0,months=0,years=1 )
    if(time_range == 'f-f'):
        time_ = get_timedate_range(minutes=0,hours=0,days=1,weeks=0,months=0,years=1000 )

    well_data_ = WellData.objects.filter(well_id=well_id,datetime__gte=time_[1], datetime__lte=time_[0]).values('datetime','water_level').order_by('-datetime')
    well_data_serialized = WellDataSerializer(well_data_, many=True).data


    return JsonResponse({
        'well_data' : well_data_serialized
    })

aqua_gauge/templates/home/index.html
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Aqua Gauge</title>
    <link href="{% static 'home/css/index.css' %}" type="text/css" rel="stylesheet">
    <!--FONT AWESOME ICONS https://fontawesome.com/v4.7/icon/home-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css" />

</head>
<style>
    .body {
        background: url("{% static 'home/images/body-bg.jpg' %}");
        background-size: cover;
    }
    .a-view{
        text-decoration: none;
    color: #666666;
    font-family: sans-serif;
    }
</style>

<body>
    <div class="main">
        <div class="header">
            <div class="flex-row-header">
                <div class="flex-col-header">
                    <h2>AquaGauge</h2>
                </div>
                <div class="flex-col-header">
                    <img class="logo" src="{% static 'home/images/icfoss_logo.png' %}" />
                </div>
                <div class="flex-col-header">
                    <a href="/manage/login" class="a-view"><h3><i class="fa fa-sign-in" aria-hidden="true"></i> Login</h3></a>
                    <!-- <img class="logo" src="{% static 'home/images/lorawan.png' %}" /> -->
                </div>
            </div>
        </div>
        <div class="body">
            <div class="body-content">
                <h1>kattakkada legislative assembly Area</h1>
                <h2>AquaGauge</h2>
                <p>Service for monitoring the water level in wells</p>
                <a href="/graphs/" class="login-btn">View Open Well Data</a>
            </div>
        </div>
        <div class="footer">
            <div class="flex-row-footer">
                <div class="flex-col-footer"></div>
                <div class="flex-col-footer">
                    <p>
                        Developed CDOH <br />
                        International Centre for Free and Open Source Software
                      </p>
                </div>
                <div class="flex-col-footer"></div>
            </div>
        </div>
    </div>

    <!--SNACKBAR MESAGE-->
    <link href="{% static 'common/css/snackbar.css' %}" type="text/css" rel="stylesheet">
    <div id="snackbar"></div>
    <script src="{% static 'common/js/snackbar.js' %}"></script>


    {% for message in messages %}
    <script>showSnackBar("{{ message }}");</script>
    {% endfor %}


</body>

</html>

aqua_gauge/templates/home/login.html
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Login</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link href="{% static 'home/css/login.css' %}" type="text/css" rel="stylesheet">
</head>

<body>
    <section>
        <div class="imgBx">
            <img src="{% static 'home/images/body-bg.jpg' %}">
            <h1>AquaGauge</h1>
            <p>Water level monitoring</p>
            <a class="home-btn" href="/" class="login-btn">Home</a>
        </div>
        <div class="contentBx">
            <div class="formBx">
                <h2>Login</h2>
                <form action="/manage/login" method="POST">
                    {% csrf_token %}
                    <div class="inputBx">
                        <span>Username</span>
                        <input type="text" name="uname" required>
                    </div>
                    <div class="inputBx">
                        <span>Password</span>
                        <input type="password" name="pass" required>
                    </div>
                    <div class="remember">
                        <label>
                            <input type="checkbox" name=""> Remember
                        </label>
                    </div>
                    <div class="inputBx">
                        <input type="submit" value="Sign in" name="">
                    </div>
                </form>

            </div>
        </div>
    </section>

    <!--SNACKBAR MESAGE-->
    <link href="{% static 'common/css/snackbar.css' %}" type="text/css" rel="stylesheet">
    <div id="snackbar"></div>
    <script src="{% static 'common/js/snackbar.js' %}"></script>


    {% for message in messages %}
    <script>showSnackBar("{{ message }}");</script>
    {% endfor %}

</body>

</html>

aqua_gauge/templates/home/signup.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>School Form</title>
    <link
      href="{% static 'home/css/index.css' %}"
      type="text/css"
      rel="stylesheet"
    />

    <style>
      /* Add some basic styling */
      body {
        font-family: Arial, sans-serif;
        background-color: #f5f5f5;
      }

      form {
        background-color: #ffffff9e;
        padding: 20px;
        margin: 20px auto;
        max-width: 80%;
        border-radius: 10px;
        box-shadow: 0 0 10px rgba(0, 0, 0, 0.2);
      }

      label {
        display: block;
        margin-bottom: 10px;
        font-weight: bold;
      }

      input[type="text"],
      input[type="password"],
      input[type="email"],
      input[type="url"] {
        width: 100%;
        padding: 10px;
        border: 1px solid #ccc;
        border-radius: 4px;
        box-sizing: border-box;
        margin-bottom: 20px;
        font-size: 16px;
      }

      select {
        width: 100%;
        padding: 10px;
        border: 1px solid #ccc;
        border-radius: 4px;
        box-sizing: border-box;
        margin-bottom: 20px;
        font-size: 16px;
      }

      button[type="submit"] {
        background-color: #4caf50;
        color: #fff;
        padding: 10px 20px;
        border: none;
        border-radius: 4px;
        cursor: pointer;
        font-size: 16px;
      }

      button[type="submit"]:hover {
        background-color: #3e8e41;
      }

      a{
        text-decoration: none;
        color: gray;
        cursor: pointer;
        display: block;
        margin-top: .5em;
      }

      .form {
        background-color: red;
        padding-top: 1em;
        padding-bottom: 1em;
        background: url("{% static 'home/images/body-bg.jpg' %}");
        background-size: cover;
      }
    </style>
  </head>

  <body>
    <div class="header">
      <div class="flex-row-header">
        <div class="flex-col-header">
          <h2>AquaGauge</h2>
        </div>
        <div class="flex-col-header">
          <img class="logo" src="{% static 'home/images/icfoss_logo.png' %}" />
        </div>
        <div class="flex-col-header">
          <img class="logo" src="{% static 'home/images/lorawan.png' %}" />
        </div>
      </div>
    </div>

    <div class="form">
      <form method="post">
        <h2>Register</h2>
        <br /><br />
        {% csrf_token %}
        <!-- Add the rest of the form fields -->
        <label for="id_name">Name:</label>
        {{ form.name }} {% if form.name.errors %}
        <ul class="errorlist">
          {% for error in form.name.errors %}
          <li>{{ error }}</li>
          {% endfor %}
        </ul>
        {% endif %}
        <label for="id_type">Type:</label>
        {{ form.type }} {% if form.name.errors %}
        <ul class="errorlist">
          {% for error in form.type.errors %}
          <li>{{ error }}</li>
          {% endfor %}
        </ul>
        {% endif %}
        <label for="id_address">Address:</label>
        {{ form.address }}
        <label for="id_phone_number">Phone number:</label>
        {{ form.phone_number }}
        <label for="id_email">Email:</label>
        {{ form.email }}
        <label for="id_website">Website:</label>
        {{ form.website }}
        <label for="id_country">Country:</label>
        {{ form.country }}
        <label for="id_state_province">State/Province:</label>
        {{ form.state_province }}
        <label for="id_city">City:</label>
        {{ form.city }}
        <label for="id_district">District:</label>
        {{ form.district }}
        <!-- Add the username and password fields -->
        <label for="id_username">Username:</label>
        {{ form.username }}
        <label for="id_password">Password:</label>
        {{ form.password }}
        <button type="submit">Submit</button>

        <a href="/manage/login">Already have an account? Login instead.</a>
      </form>
    </div>

    <div class="footer">
      <div class="flex-row-footer">
        <div class="flex-col-footer"></div>
        <div class="flex-col-footer">
          <p>
            Developed CDOH <br />
            International Centre for Free and Open Source Software
          </p>
        </div>
        <div class="flex-col-footer"></div>
      </div>
    </div>

    <!--SNACKBAR MESAGE-->
    <link
      href="{% static 'common/css/snackbar.css' %}"
      type="text/css"
      rel="stylesheet"
    />
    <div id="snackbar"></div>
    <script src="{% static 'common/js/snackbar.js' %}"></script>

    {% for message in messages %}
    <script>
      showSnackBar("{{ message }}");
    </script>
    {% endfor %}
  </body>
</html>